#!/bin/bash

set -e

if [ "$#" -ne 1 ]; then
    echo "Illegal number of parameters"
    echo "Usage: ./set_tcl_active_version.sh version"
    exit 1
fi

version="$1"

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

if [ ! -f $DIR/ixtcl$version* ] || [ ! -f $DIR/ixwish$version* ]; then
    echo "TCL $version not found!"
    exit 1
fi

(cd $DIR && ln -nfs ixtcl$version* ixtcl)
(cd $DIR && ln -nfs ixwish$version* ixwish)

echo "Successfully changed active TCL version to $version."
